/**
*
*  EVO 2017 -- Aplikovan evolun algoritmy
*      pracovn soubor pro cvien . 3
* --------------------------------------------
* Genetick programovn -- symbolick regrese
* --------------------------------------------
*
* peklad: gcc -o gp gp.c -std=c99 -Wall -pedantic -lm
*
* autor: Martin Hyr
* 15. 3. 2017 (pvodn projekt do BIN2012: CGP 2D symbolick regrese)
*
*/



#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <float.h>
#include <string.h>
#include <time.h>
#include <stdbool.h>

/// velikost populace, poet generac
#define NPOP 500
#define MAXGEN 100


// ka pole pro strom o hloubce H je 2^H (poet uzl je jenom 2^H-1, ale budeme indexovat od 1)
// pokud bude pole men, bude stromu na prav stran chybt posledn patro (ale to niemu nevad)
// WIDTHstart je "hloubka" pro inicializaci
// WIDTHtotal je celkov alokovan hloubka, ideln nekoneno, prakticky ns limituje pam. Meme tm ale omezit bloat.
#define WIDTHstart 64
#define WIDTHtotal 65536


#define PCROS 0.7
#define PMUT 0.1




/// ///////////////////////////////////////////////////////
/// testovac data

/*
#define TESTCOUNT 5
double testdata[TESTCOUNT][2] = {
	{0.0 ,   1.0},
	{1.0 ,   3.0},
	{2.0 ,   7.0},
	{3.0 ,   13.0},
	{4.0 ,   21.0}
};
void createTestData () {}
//*/

//*
#define TESTCOUNT 31
#define STARTPOINT -10
#define STEPPOINT 0.666666
double testdata[TESTCOUNT][2];
void createTestData () {
	for (int i=0; i<TESTCOUNT; i++) {
		double x = i*STEPPOINT + STARTPOINT;
		double fx = (sin(x)/x);
		testdata[i][0] = x;
		testdata[i][1] = fx;
	}
}//*/



/*
double fce (double x) {
	return (1/(x*x+1));
}
#define TESTCOUNT 31
#define STARTPOINT -3
#define STEPPOINT 0.333333
#define DX 16
double testdata[TESTCOUNT][2];
void createTestData () {
	testdata[0][0] = STARTPOINT;
	testdata[0][1] = 0;
	for (int i=1; i<TESTCOUNT; i++) {
		double x = testdata[i-1][0];
		double fx = testdata[i-1][1];
		for (int j=0; j<DX; j++) {
			x += STEPPOINT/DX;
			fx += fce(x)*(STEPPOINT/DX);
		}
		testdata[i][0] = x;
		testdata[i][1] = fx;
	}
}//*/

///
/// testovac data
/// ///////////////////////////////////////////////////////








/// ///////////////////////////////////////////////////////
/// nhodn genertory

/** generator rovnomernych nahodnych CELYCH cisel v intervalu <0, max) neboli <0, max-1> */
int nahodne(int max) {
	return rand()/(double)RAND_MAX * max;
}

/** generator rovnomernych nahodnych cisel v intervalu <a; b) */
double randomUab (double a, double b) {
	return rand()/(double)RAND_MAX * (b-a) + a;
}

/** se zadanou pravdepodobnosti vraci true */
bool flipCoin (double p) {
	return randomUab(0,1)<p;
}

///
/// ///////////////////////////////////////////////////////










/// ///////////////////////////////////////////////////////
/// definice chromozomu

/** vechny znm typy uzlu */
typedef enum {
	VARX, // nejprve terminly
	VARY,
	KONST1,
	KONST2,
	KONST3,
	KONSTm1,

	PLUS, // toto je prvn nonterminl!
	MINUS,
	KRAT,
	DELENO,
	LOG,
	EXP,
	POW,
	SIN,
	COS,
	ATAN,

	COUNT
} funkce;
/*
typ ENUM v jazyce C je maskovan INTEGER!
COUNT proto udv celkov poet monch typ uzl.
PLUS je prvn nonterminl, proto udv poet terminl (kter jsou ve vtu ped nm).
*/
#define TermCOUNT PLUS



typedef struct {
	funkce f;
} gen;


/**
 Bude to binrn strom kdovan pomoc pole,
 tzn. potomci i jsou na indexech 2i, 2i+1
 (za pedpokladu indexace od 1, proto WIDTHstart o jedna vt)
 Nkter uzly nevyuijeme, ale to nm vad.
*/
typedef gen chromozom[WIDTHtotal];


chromozom *populace[NPOP];
double fitnessPop[NPOP+1];

///
/// ///////////////////////////////////////////////////////






/// ///////////////////////////////////////////////////////
/// vyhodnocen a vpis

double X,Y;

/** spot hodnotu genu i na chromozomu chr*/
double hodnotaGenu(chromozom *chr, int i) {
	gen g = (*chr)[i];
	switch (g.f) {
		case VARX:
			return X;
		case VARY:
			return X;
		case KONST1:
			return 1;
		case KONST2:
			return 2;
		case KONST3:
			return 3;
		case KONSTm1:
			return -1;
		case PLUS:
			return hodnotaGenu(chr, 2*i) + hodnotaGenu(chr, 2*i+1);
		case MINUS:
			return hodnotaGenu(chr, 2*i) - hodnotaGenu(chr, 2*i+1);
		case KRAT:
			return hodnotaGenu(chr, 2*i) * hodnotaGenu(chr, 2*i+1);
		case DELENO:
			return hodnotaGenu(chr, 2*i) / hodnotaGenu(chr, 2*i+1);
		case LOG:
			return log(hodnotaGenu(chr, 2*i));
		case EXP:
			return exp(hodnotaGenu(chr, 2*i));
		case POW:
			return pow(hodnotaGenu(chr, 2*i),hodnotaGenu(chr, 2*i+1));
		case SIN:
			return sin(hodnotaGenu(chr, 2*i));
		case COS:
			return cos(hodnotaGenu(chr, 2*i));
		case ATAN:
			return atan(hodnotaGenu(chr, 2*i));
		default:
			return -1;
	}
}

/** vype hodnotu genu i na chromozomu chr*/
void tiskniGen(FILE* file, chromozom *chr, int i) {
	gen g = (*chr)[i];
	switch (g.f) {
		case VARX:
			fprintf(file, "x");
			return;
		case VARY:
			fprintf(file, "x");
			return;
		case KONST1:
			fprintf(file, "%d", 1);
			return;
		case KONST2:
			fprintf(file, "%d", 2);
			return;
		case KONST3:
			fprintf(file, "%d", 3);
			return;
		case KONSTm1:
			fprintf(file, "%d", -1);
			return;
		case PLUS:
			fprintf(file, "(");
			tiskniGen(file, chr, 2*i);
			fprintf(file, ")+(");
			tiskniGen(file, chr, 2*i+1);
			fprintf(file, ")");
			return;
		case MINUS:
			fprintf(file, "(");
			tiskniGen(file, chr, 2*i);
			fprintf(file, ")-(");
			tiskniGen(file, chr, 2*i+1);
			fprintf(file, ")");
			return;
		case KRAT:
			fprintf(file, "(");
			tiskniGen(file, chr, 2*i);
			fprintf(file, ")*(");
			tiskniGen(file, chr, 2*i+1);
			fprintf(file, ")");
			return;
		case DELENO:
			fprintf(file, "(");
			tiskniGen(file, chr, 2*i);
			fprintf(file, ")/(");
			tiskniGen(file, chr, 2*i+1);
			fprintf(file, ")");
			return;
		case LOG:
			fprintf(file, "log(");
			tiskniGen(file, chr, 2*i);
			fprintf(file, ")");
			return;
		case EXP:
			fprintf(file, "exp(");
			tiskniGen(file, chr, 2*i);
			fprintf(file, ")");
			return;
		case POW:
			fprintf(file, "(");
			tiskniGen(file, chr, 2*i);
			fprintf(file, ")**(");
			tiskniGen(file, chr, 2*i+1);
			fprintf(file, ")");
			return;
		case SIN:
			fprintf(file, "sin(");
			tiskniGen(file, chr, 2*i);
			fprintf(file, ")");
			return;
		case COS:
			fprintf(file, "cos(");
			tiskniGen(file, chr, 2*i);
			fprintf(file, ")");
			return;
		case ATAN:
			fprintf(file, "atan(");
			tiskniGen(file, chr, 2*i);
			fprintf(file, ")");
			return;
		default:
			return;
	}
}

///
/// ///////////////////////////////////////////////////////




/// ///////////////////////////////////////////////////////
/// analza stromu

/** Rozhodne, zda m dan gen na danm chromozou mt levho potomka.
	(= funkce nebo binrn operace) */
bool maLevyPodstrom (chromozom *chr, int i) {
	gen g = (*chr)[i];
	switch (g.f) {
		case PLUS:
		case MINUS:
		case KRAT:
		case DELENO:
		case LOG:
		case EXP:
		case POW:
		case SIN:
		case COS:
		case ATAN:
			return true;
		default:
			return false;
	}
}

/** Rozhodne, zda m dan gen na danm chromozou mt pravho potomka.
	(= binrn operace) */
bool maPravyPodstrom (chromozom *chr, int i) {
	gen g = (*chr)[i];
	switch (g.f) {
		case PLUS:
		case MINUS:
		case KRAT:
		case DELENO:
		case POW:
			return true;
		default:
			return false;
	}
}

/** Hloubka stromu, potno pro dan podstrom */
int hloubkaStromu (chromozom *chr, int i) {
	int l=1, p=1;
	if (maLevyPodstrom(chr,i)) {
		l += hloubkaStromu(chr, i*2);
	}
	if (maPravyPodstrom(chr,i)) {
		p += hloubkaStromu(chr, i*2+1);
	}
	return l>p ? l : p;
}

/** Poet uzl ve stromu, potno pro dan podstrom */
int velikostStromu (chromozom *chr, int i) {
	int v=1;
	if (maLevyPodstrom(chr,i)) {
		v += velikostStromu(chr, i*2);
	}
	if (maPravyPodstrom(chr,i)) {
		v += velikostStromu(chr, i*2+1);
	}
	return v;
}


/** Najde n-t (potno od 1.) uzel ve stromu */
int projitychUzlu, hledanyUzel;
int projdiPodstrom (chromozom *chr, int i) {
	projitychUzlu++;
	if (projitychUzlu==hledanyUzel) {
		return i;
	}
	if (maLevyPodstrom(chr,i)) {
		int u = projdiPodstrom(chr, i*2);
		if (u>0) return u;
	}
	if (maPravyPodstrom(chr,i)) {
		int u = projdiPodstrom(chr, i*2+1);
		if (u>0) return u;
	}
	return -1;
}
int najdiUzel (chromozom *chr, int n) {
	projitychUzlu = 0;
	hledanyUzel = n;
	int u = projdiPodstrom(chr, 1);
	if (u<=0) {
		fprintf(stderr, "### hledani uzlu por.c. %d se nezdarilo\n", n);
	}
	return u;
}


///
/// ///////////////////////////////////////////////////////







/// ///////////////////////////////////////////////////////
/// opertory


/** init Grow - roste nhodn */
// sprvn by se mlo zat koenem a jt po vtvch, takhle se mon nainicializuje i to co by nemuselo.
void initGrow(chromozom *chr) {
	for (int i=1; i<WIDTHstart; i++) {
		(*chr)[i].f = nahodne(COUNT);
		if (i*2>=WIDTHstart) { // uzly, ktere nemohou mit potomka, musi byt terminaly
			(*chr)[i].f = nahodne(TermCOUNT);
		}
	}
}

/** init Full - vyroste cel */
void initFull(chromozom *chr) {
	for (int i=1; i<WIDTHstart; i++) {
		(*chr)[i].f = (int) randomUab(TermCOUNT, COUNT) + TermCOUNT;
		if (i*2>=WIDTHstart) { // uzly, ktere nemohou mit potomka, musi byt terminaly
			(*chr)[i].f = nahodne(TermCOUNT);
		}
	}
}


/** kopie chromozomu */
void kopiruj(chromozom *dst, chromozom *src) {
	if (dst==src) return;
	//memcpy(dst, src, sizeof(gen)*(WIDTHtotal));
	memcpy(dst, src, sizeof(chromozom));
}


/** Mutuje jeden nhodn zvolen uzel. "Neutrln" mutace - vbec nee, jestli je dan uzel aktivn. */
void mutaceUzel(chromozom *chr) {
	int i = nahodne(WIDTHtotal-1)+1; // nhodn vbr genu
	(*chr)[i].f = nahodne(COUNT);
	if (i*2>=WIDTHtotal) { // uzly, ktere nemohou mit potomka, musi byt terminaly
		(*chr)[i].f = nahodne(TermCOUNT);
	}
}


/** Zmutuje zadan chromozom, vygeneruje nhodn podstrom msto genu i */
void mutacePodstrom (chromozom *chr, int i) {
	(*chr)[i].f = nahodne(COUNT);
	if (i*2>=WIDTHtotal) { // uzly, ktere nemohou mit potomka, musi byt terminaly
		(*chr)[i].f = nahodne(TermCOUNT);
	}
	if (maLevyPodstrom(chr,i)) {
		mutacePodstrom(chr, i*2);
	}
	if (maPravyPodstrom(chr,i)) {
		mutacePodstrom(chr, i*2+1);
	}
}


/** Ken -- vymn podstromy v danch chromozomech na danch genech */
// kopruje vtinu stromu zbyten, ale funguje
void krizeniPodstromy (chromozom *chrA, int iA, bool zAdoB,  chromozom *chrB, int iB, bool zBdoA) {
/*fprintf(stderr,"(%d %d ",iA,iB);
	// jestli se nem koprovat ani v jednom smru, tak toho nech. Nebo kdy nen odkud brt.
	if (! (zAdoB||zBdoA)) { fprintf(stderr,">"); return;}
	if (iA>=WIDTHtotal) { fprintf(stderr,"}"); return;}
	if (iB>=WIDTHtotal) { fprintf(stderr,"]"); return;}
	// proho uzly
	int fA = (*chrA)[iA].f;
	int fB = (*chrB)[iB].f;
	if (zBdoA) { (*chrA)[iA].f = fB; }
	if (zAdoB) { (*chrB)[iB].f = fA; }
	// pokud by se nonterminl (m alespo levho potomka) nakoproval na msto, kde mus bt terminl,
	// vra tam pvodn hodnotu, co musel bt terminl
	if (iA*2>=WIDTHtotal && maLevyPodstrom(chrA,iA)) { (*chrA)[iA].f = fA; }
	if (iB*2>=WIDTHtotal && maLevyPodstrom(chrB,iB)) { (*chrB)[iB].f = fB; }
	// pokud maj podstromy, proho i podstromy (rodie u jsou prohozen)
	krizeniPodstromy ( chrA, iA*2, zAdoB&&maLevyPodstrom(chrB,iB),  chrB, iB*2, zBdoA&&maLevyPodstrom(chrA,iA) );
fprintf(stderr,"|");
	krizeniPodstromy ( chrA, iA*2+1, zAdoB&&maPravyPodstrom(chrB,iB),  chrB, iB*2+1, zBdoA&&maPravyPodstrom(chrA,iA) );
fprintf(stderr,")");*/
	// jestli se nem koprovat ani v jednom smru, tak toho nech. Nebo kdy nen odkud brt.
	if (! (zAdoB||zBdoA)) { return; }
	if (iA>=WIDTHtotal) { return; }
	if (iB>=WIDTHtotal) { return; }
	// proho uzly
	int fA = (*chrA)[iA].f;
	int fB = (*chrB)[iB].f;
	if (zBdoA) { (*chrA)[iA].f = fB; }
	if (zAdoB) { (*chrB)[iB].f = fA; }
	// a jestli jsme na konci, dej tam nhodn terminl
	if (iA*2>=WIDTHtotal) { (*chrA)[iA].f = nahodne(TermCOUNT); }
	if (iB*2>=WIDTHtotal) { (*chrB)[iB].f = nahodne(TermCOUNT); }
	// proho  podstromy
	krizeniPodstromy( chrA, iA*2,   zAdoB&&maLevyPodstrom(chrB,iB),  chrB, iB*2,   zBdoA&&maLevyPodstrom(chrA,iA) );
	krizeniPodstromy( chrA, iA*2+1, zAdoB&&maPravyPodstrom(chrB,iB), chrB, iB*2+1, zBdoA&&maPravyPodstrom(chrA,iA) );
}

///
/// ///////////////////////////////////////////////////////


















/// ///////////////////////////////////////////////////////
/// fitness

double tolerance = 0.0;

/** spot fitness chromozomu */
double fitness(chromozom *chr) {
	double retval = 0.0;
	for (int tc=0; tc<TESTCOUNT; tc++) {
		X = testdata[tc][0];
		double diff = fabs( hodnotaGenu(chr, 1) - testdata[tc][1] );

		if (!isfinite(diff)) {
			diff = 10*tolerance;
		}

		// bu poet hit
		if (diff>tolerance) {
			retval += tolerance;
		}

		// nebo hrub fitness (je tohle bezpen?!!!)
		//retval += diff;
	}
	return retval;
}


/** spot fitness chromozomu s ignorac posunu - rozdly mezi dvojic bod mus bt stejn ve vzoru i v kandidtovi */
double fitnessInt(chromozom *chr) {
	double hodnoty[TESTCOUNT];
	for (int i=0; i<TESTCOUNT; i++) {
		X = testdata[i][0];
		hodnoty[i] = hodnotaGenu(chr, 1);
	}
	double retval = 0.0;
	for (int i=0; i<TESTCOUNT; i++) {
		for (int j=0; j<TESTCOUNT; j++) {
			double diffVzor = testdata[i][1] - testdata[j][1];
			double diffKand = hodnoty[i] - hodnoty[j];
			if ( (fabs(diffVzor-diffKand)>tolerance) || !(isfinite(diffKand)) ) {
				retval += tolerance;
			}
		}
	}
	return retval;
}

///
/// ///////////////////////////////////////////////////////










/// ///////////////////////////////////////////////////////
/// evoluce

/** Provede jednu generaci GP. Vrac index nejlepho jedince. */
int generaceGP() {
	for (int p=0; p<NPOP; p+=2) {
		// 1) turnajem vybereme dva rodie
		// 2) dalm opanm turnajem vybereme dva patn jedince
		// 3) rodie nahrad ty patn jedince
		// 4) mon se zk
		// 5) mon se zmutuj

		int Mom, Dad, OtherMother, OtherFather,  Coraline, Doll, Wybie, OtherWybie;
		Mom = nahodne(NPOP);
		Dad = nahodne(NPOP);
		OtherMother = nahodne(NPOP);
		OtherFather = nahodne(NPOP);
		Coraline = nahodne(NPOP);
		Doll = nahodne(NPOP);
		Wybie = nahodne(NPOP);
		OtherWybie = nahodne(NPOP);

		if (fitnessPop[OtherMother]<fitnessPop[Mom]) Mom = OtherMother;
		if (fitnessPop[OtherFather]<fitnessPop[Dad]) Dad = OtherFather;

		if (fitnessPop[Doll]>fitnessPop[Coraline]) Coraline = Doll;
		if (fitnessPop[OtherWybie]>fitnessPop[Wybie])  Wybie = OtherWybie;


		kopiruj(populace[Coraline], populace[Dad]);
		kopiruj(populace[Wybie], populace[Mom]);


		if (flipCoin(PCROS)) {
			int velC = velikostStromu(populace[Coraline], 1);
			int adrC = najdiUzel(populace[Coraline], nahodne(velC)+1);
			int velW = velikostStromu(populace[Wybie], 1);
			int adrW = najdiUzel(populace[Wybie], nahodne(velW)+1);
			krizeniPodstromy( populace[Coraline], adrC, true,  populace[Wybie], adrW, true);
		}


		if (flipCoin(PMUT)) {
			int velC = velikostStromu(populace[Coraline], 1);
			int adrC = najdiUzel(populace[Coraline], nahodne(velC)+1);
			mutacePodstrom(populace[Coraline], adrC);
		}
		if (flipCoin(PMUT)) {
			int velW = velikostStromu(populace[Wybie], 1);
			int adrW = najdiUzel(populace[Wybie], nahodne(velW)+1);
			mutacePodstrom(populace[Wybie], adrW);
		}


		fitnessPop[Coraline] = fitness(populace[Coraline]);
		fitnessPop[Wybie] = fitness(populace[Wybie]);
	}

	double bestfit = INFINITY;
	double avgfit = 0;
	int bestind = 0;
	for (int p=0; p<NPOP; p++) {
        avgfit += fitnessPop[p];
		if (fitnessPop[p]<bestfit) {
			bestfit = fitnessPop[p];
			bestind = p;
		}
	}
	fitnessPop[NPOP] = avgfit/NPOP;
	return bestind;
}





/** Provede jednu generaci
vyhodnot fitness vech jedinc,
vybere nejlepho, rozmno ho. */
int generaceES() {
	double bestfit = INFINITY;
	int bestchr = 0;

	for (int i=0; i<NPOP; i++) {
		if (fitnessPop[i]<=bestfit) { // prochzm od rodie, lep roven nahrad
			bestfit = fitnessPop[i];
			bestchr = i;
		}
	}
	kopiruj(populace[0], populace[bestchr]);
	fitnessPop[0] = bestfit;

	for (int i=1; i<NPOP; i++) {
		kopiruj(populace[i], populace[0]);
		for (int j=0; j<PMUT*WIDTHtotal; j++) { // potomek vznik mutac rodie
			mutaceUzel(populace[i]);
		}
		fitnessPop[i] = fitness(populace[i]);
	}
	return 0; // vrac toho nejlepho v pedel generaci
}

///
/// ///////////////////////////////////////////////////////







/// ///////////////////////////////////////////////////////
/// main

int main(int argc, char *argv[]) {

	srand (time(NULL));
	createTestData();

	double max=-INFINITY, min=INFINITY;
	for (int i=0; i<TESTCOUNT; i++) {
		if (testdata[i][1]>max) max = testdata[i][1];
		if (testdata[i][1]<min) min = testdata[i][1];
	}
	tolerance = (max-min)*0.01;


	for (int i=0; i<NPOP; i++) {
		populace[i] = malloc(sizeof(chromozom));
	}


	for (int i=0; i<NPOP; i++) {
		initGrow(populace[i]);
		fitnessPop[i] = fitness(populace[i]);
	}

/// ///////////////////////////////////////////////////////

	int g, best;
	for (g=1; g<MAXGEN; g++) {
		best = generaceGP();
		fprintf(stderr,"gen %d: fit=%f (avg=%f), velikost=%d hloubka=%d\n   ", g, fitnessPop[best], fitnessPop[NPOP],  velikostStromu(populace[best],1), hloubkaStromu(populace[best],1) );
		tiskniGen(stderr, populace[best], 1);
		fprintf(stderr, "\n");
		if (fitnessPop[best]==0) break;
	}

/// ///////////////////////////////////////////////////////

	fprintf(stdout, "set grid\n plot '-' w points pt 7 lc 7 ps 3 t '', ");
	//fprintf(stdout, "set ytics nomirror\n set y2tics\n set grid\n plot '-' w points pt 7 lc 7 ps 3 t '', ");
	tiskniGen(stdout, populace[best], 1);
	fprintf(stdout, " lw 5 \n");
	//fprintf(stdout, " axis x1y2 lw 5 \n");
	for (int t=0; t<TESTCOUNT; t++) {
		fprintf(stdout, "%f %f\n", testdata[t][0], testdata[t][1]);
	}
	fprintf(stdout, "e\n");


	for (int i=0; i<NPOP; i++) {
		free(populace[i]);
	}

	return 0;
}

///
/// ///////////////////////////////////////////////////////
